Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.collation
Class CollationKeyAnalyzer

    java.lang.Object
      org.apache.lucene.analysis.Analyzer
          org.apache.lucene.collation.CollationKeyAnalyzer

All Implemented Interfaces:
  Closeable

    public final class CollationKeyAnalyzer

extends Analyzer

Configures `KeywordTokenizer` with `CollationAttributeFactory`.

Converts the token into its `CollationKey`, and then encodes the CollationKey either directly or with `IndexableBinaryStringTools` (see below), to allow it to be stored as an index term.

WARNING: Make sure you use exactly the same Collator at index and query time -- CollationKeys are only comparable when produced by the same Collator. Since `RuleBasedCollator`s are not independently versioned, it is unsafe to search against stored CollationKeys unless the following are exactly the same (best practice is to store this information with the index and check that they remain the same at query time):

1. JVM vendor
2. JVM version, including patch version
3. The language (and country and variant, if specified) of the Locale used when constructing the collator via `Collator.getInstance(java.util.Locale)`.
4. The collation strength used - see `Collator.setStrength(int)`

The `ICUCollationKeyAnalyzer` in the analysis-icu package uses ICU4J's Collator, which makes its its version available, thus allowing collation to be versioned independently from the JVM. ICUCollationKeyAnalyzer is also significantly faster and generates significantly shorter keys than CollationKeyAnalyzer. See http://site.icu-project.org/charts/collation-icu4j-sun for key generation timing and key length comparisons between ICU4J and java.text.Collator over several languages.

CollationKeys generated by java.text.Collators are not compatible with those those generated by ICU Collators. Specifically, if you use CollationKeyAnalyzer to generate index terms, do not use ICUCollationKeyAnalyzer on the query side, or vice versa.

You must specify the required `Version` compatibility when creating CollationKeyAnalyzer:

- As of 4.0, Collation Keys are directly encoded as bytes. Previous versions will encode the bytes with `IndexableBinaryStringTools`.

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.lucene.analysis.Analyzer
`Analyzer.GlobalReuseStrategy, Analyzer.PerFieldReuseStrategy, Analyzer.ReuseStrategy, Analyzer.TokenStreamComponents`

Constructor Summary
`CollationKeyAnalyzer(Collator collator)` Deprecated. Use `CollationKeyAnalyzer(Version, Collator)` and specify a version instead. This ctor will be removed in Lucene 5.0
`CollationKeyAnalyzer(Version matchVersion, Collator collator)` Create a new CollationKeyAnalyzer, using the specified collator.

Method Summary
`protected Analyzer.TokenStreamComponents` | `createComponents(String fieldName, Reader reader)`

Methods inherited from class org.apache.lucene.analysis.Analyzer
`close, getOffsetGap, getPositionIncrementGap, initReader, tokenStream`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CollationKeyAnalyzer

    public CollationKeyAnalyzer(Version matchVersion,
                                Collator collator)

  Create a new CollationKeyAnalyzer, using the specified collator.

  Parameters:
    `matchVersion` - See above
    `collator` - CollationKey generator

### CollationKeyAnalyzer

    @Deprecated
    public CollationKeyAnalyzer(Collator collator)

  Deprecated. Use `CollationKeyAnalyzer(Version, Collator)` and specify a version instead. This ctor will be removed in Lucene 5.0

Method Detail

### createComponents

    protected Analyzer.TokenStreamComponents createComponents(String fieldName,
                                                              Reader reader)

  Specified by:
    `createComponents` in class `Analyzer`

Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.